var accionPlano="";
var accion = document.editarPlanoForm.accion.value;
var coordX = 0;
var coordY = 0;
var combosCreados=false;
	
	
	$( document ).ready(function() {
	var accion = document.editarPlanoForm.accion.value;		
		if (accion == "NUEVO") {
		    $("#botoneraModificar").hide();       
		    //$("#checkboxBaja").hide();
		    $("#botoneraNuevo").show();    
		}  else {
			   $("#botoneraModificar").show();
	 	      // $("#checkboxBaja").show();
		       $("#botoneraNuevo").hide();	
		       obtenerPlano();
		}
		$("#bt_asociarHijos").bind("click", asociarPlanoHijo);
		
		//Si estamos en añadir plano hijo, cuando haga click pintaremos un punto rojo y cogeremos la coordernada en la que ha hecho clik  para guardarlo en la base de datos.
		$('#canvaPlano1').on('mouseup', function(e){
			var pos = getMousePos(this, e);
			coordX = Math.floor(pos.x);
			coordY = Math.floor(pos.y);
			if (accionPlano=="asociarPlanoHijo"){
				pintarX(pos.x,pos.y);
				seleccionarPlanoHijo();
				
			}else if (accionPlano=="verPlano"){
				/*
				//recorremos el array de coordenada para ver si ha pinchado en una zona alrededor de un punto rojo (+-15) 
				jQuery.each( arrayPlanos, function( i, val ) {
					if ((parseInt(arrayPlanos[i].coordX) - 15)<(parseInt(pos.x)) && (parseInt(arrayPlanos[i].coordX) + 15)>(parseInt(pos.x)) && 
							(parseInt(arrayPlanos[i].coordY) - 15)<(parseInt(pos.y)) && (parseInt(arrayPlanos[i].coordY) + 15)>(parseInt(pos.y))		
					) {
						//Cargar el plano hijo
						cargarCanvasLupaIDPlano(arrayPlanos[i].idplano);
						planoFinal=true;
					}
				});
				*/
			}
		});
		
	});

	$("#fileupload_only").rup_upload({
		fileInput: $("#file_only"),
		maxFileSize: 5000000
		});
	
	$('#fileupload_only').bind('fileuploaddone', function (e, data) {
		$('#tablaResultadoSubida').hide();
		obtenerPlano();
	});
	
	$('#fileupload_only').bind('fileuploadadd', function (e, data) {
		$('#tablaResultadoSubida').show();
	});

	$("#bt_Volver").bind("click", volver);
	function volver(){
		window.location = "/aa20bMaqPartesWar/planos/maintVolver";	
	}
	
	
	
	
	/********************************* FEEDBACK MENSAJES OK  ****************************************************************/
	
	function mensajeInfo (texto) {
		 var properties = {
   				type: "ok",
   				fadeSpeed: 600,
   				gotoTop: false,
   				block: false,
   				closeLink: false
   			};
   		$("#feedbackEditarPlano").rup_feedback (properties);

   		$("#feedbackEditarPlano").rup_feedback("set", texto);

   		$("#feedbackEditarPlano").rup_feedback("show");
	}
	
	
	/* Error */
	function mensajeError (texto) {
		 var properties = {
 				type: "error",
 				fadeSpeed: 600,
 				gotoTop: false,
 				block: false,
 				closeLink: false
 			};
 	
 		$("#feedbackEditarPlano").rup_feedback (properties);

 		$("#feedbackEditarPlano").rup_feedback("set", texto);

 		$("#feedbackEditarPlano").rup_feedback("show");
	}
	/********************************* FIN FEEDBACK MENSAJES OK  ****************************************************************/

	

	jQuery("#feedbackEditarPlano").rup_feedback({
		  type: "ok",                  
		  closeLink: true,                  
		  delay: 1000,                  
		  fadeSpeed: 500,                  
		  block:true          
		  }); 


/**********************************************************************************/
/******************************** IMAGEN PLANO   **********************************/
/**********************************************************************************/
	function obtenerPlano(){
		var codEdif = $("#idedificio").val();
		var codPlanta = $("#idplanta").val();
		var codZona = $("#idzona").val();

		var planoDetalle=null;

		cPunto = document.getElementById("canvaPunto");
		ctxPunto = cPunto.getContext("2d");
		
		planoDetalle = new Image();
		planoDetalle.onload=function(){
			ctxPunto.clearRect( 0, 0, 390, 312);
			ctxPunto.drawImage(planoDetalle, 0, 0, 390, 312);
			//width="300" height="240"
		};
		//planoParte.src="../parteplano/mostrarPlanoParte?idParte=90"; //+ $("#idparte").val();
		planoDetalle.src="../planos/mostrarPlano?edificio=" + codEdif + "&planta=" + codPlanta + "&zona=" + codZona + "&" + new Date().getTime();
		
		
	}
function btn_cargarPlano(){
	var codEdif = $("#idedificio").val();
	var codPlanta = $("#idplanta").val();
	var codZona = $("#idzona").val();
	//Mostrar la ventana de lupa del plano
	$("#lupaPlano").rup_dialog({      
		type: jQuery.rup.dialog.DIV,
		modal:true,
        height:750,
        width:850,  
        resizable:false,
        title:"",
        autoOpen:true,
        showLoading:true,
        async:false, 
        zIndex: -1,
        buttons:[
	        {
	    		id: "cerrarLupaPlano",
	    		text: $.rup.i18n.base.rup_global.cancelar,
	        	click: function() {
	        		$("#lupaPlano").rup_dialog("close");
	        	},
	        	btnType:$.rup.dialog.LINK
        	}]
      });
	
	 cPunto = document.getElementById("canvaPlano1");
	 ctxPunto = cPunto.getContext("2d");
	
	 planoLupa = new Image();
	 planoLupa.onload=function(){
		 ctxPunto.clearRect( 0, 0, 800, 640);
			ctxPunto.drawImage(planoLupa, 0, 0, 800, 640);
	};
	planoLupa.src="../planos/mostrarPlano?edificio=" + codEdif + "&planta=" + codPlanta + "&zona=" + codZona;

	accionPlano="verPlano";
}

function asociarPlanoHijo(e){
	e.preventDefault();
	var codEdif = $("#idedificio").val();
	var codPlanta = $("#idplanta").val();
	var codZona = $("#idzona").val();
	//Mostrar la ventana de lupa del plano
	$("#lupaPlano").rup_dialog({      
		type: jQuery.rup.dialog.DIV,
		modal:true,
        height:750,
        width:850,  
        resizable:false,
        title:"",
        autoOpen:true,
        showLoading:true,
        async:false, 
        zIndex: -1,
        buttons:[
	        {
	    		id: "cerrarLupaPlano",
	    		text: $.rup.i18n.base.rup_global.cancelar,
	        	click: function() {
	        		$("#lupaPlano").rup_dialog("close");
	        	},
	        	btnType:$.rup.dialog.LINK
        	}]
      });
	
	 cPunto = document.getElementById("canvaPlano1");
	 ctxPunto = cPunto.getContext("2d");
	
	 planoLupa = new Image();
	 planoLupa.onload=function(){
		 ctxPunto.clearRect( 0, 0, 800, 640);
			ctxPunto.drawImage(planoLupa, 0, 0, 800, 640);
	};
	planoLupa.src="../planos/mostrarPlano?edificio=" + codEdif + "&planta=" + codPlanta + "&zona=" + codZona;

	$("#tituloZoomPlano").html($.rup.i18n.app.mensajesPlano.marcarPlanoHijo);
	
	accionPlano="asociarPlanoHijo";
	

	//Controlar si ya están creados los combos para no volver a crearlos
	if (combosCreados==false){
		combosCreados=true;
		//Edificio
		$("#comboEdificios").rup_combo({
			source: "../edificios/edificiosConPlanos/combo/remote",
			sourceParam: {label:obtenerIdiomaCombo()+"edificio", value:"idedificio"},
			width: 339,
			blank: "",
			//seleccionar en el combo de edificios el edificio asociado al parte para que se pueda recargar Zona y Planta
			selected: accion != "NUEVO"?$("#idEdificio").val():"",
			select: function(){
				//asignar el valor seleccionado al campo del formulario que actualiza el valor
				$("#idEdificio").val($("#comboEdificios").rup_combo("value"));
				comprobarCombos();
				
			},
			style : "dropdown"										
		});

		$("#comboZonas").rup_combo({
			parent: [ "comboEdificios"],
			source: "../zonas/zonasEdifConPlanos/combo/remote",
			sourceParam: {label:obtenerIdiomaCombo() + "zona", value:"idzona"},
			select : function() { 
				$("#idZona").val($("#comboZonas").val());
				comprobarCombos();
			},
			width: 150,
			blank: "",
			style : "dropdown"										
		});

		$("#comboPlantas").rup_combo({
			parent: [ "comboZonas", "comboEdificios"],
			source: "../plantas/plantasZonaConPlanos/combo/remote",
			sourceParam: {label:obtenerIdiomaCombo() + "planta", value:"idplanta"},
			//selected: "0",
			ordered: false,
			select : function() { 
				$("#idPlanta").val($("#comboPlantas").val());
				
				comprobarCombos();
			},
			width: 150,
			blank: "",
			style : "dropdown"										
		});
	}

}

function pintarX(x,y){

	//$("#aceptarLupaPlano").show();	
	
	ctxPunto.clearRect( 0, 0, 800, 640);
	ctxPunto.drawImage(planoLupa, 0, 0, 800, 640);
	ctxPunto.fillStyle="#FF0000";
	ctxPunto.beginPath(); 
	ctxPunto.arc(x, y, 10, 0, 2 * Math.PI, true); 
	ctxPunto.fill();
	
	var canvas; 
	canvas=document.getElementById("canvaPlano1");
	var url = canvas.toDataURL();
	 var byteString;
     if (url.split(',')[0].indexOf('base64') >= 0) {
         byteString = url.split(',')[1];
     } 
     
     //Metemos la imagen en el input que se va a enviar para guardar en base de datos la imagen
	$("#planoMarca").val(byteString);
}

function getMousePos(canvas, evt) {
    var rect = canvas.getBoundingClientRect();
    return {
        x: evt.clientX - rect.left,
        y: evt.clientY - rect.top
    };
}

function seleccionarPlanoHijo(){

	//Mostrar la ventana de lupa del plano
	$("#selecPlanoHijo").rup_dialog({      
		type: jQuery.rup.dialog.DIV,
		modal:true,
        height:250,
        width:850,  
        resizable:false,
        title:$.rup.i18n.app.mensajesPlano.tituloSelecHijo,
        autoOpen:true,
        showLoading:true,
        async:false, 
        zIndex: -1,
        buttons:[{
        		id: "aceptarSelecPlanoHijo",
        		text: $.rup.i18n.base.rup_global.aceptar,
        		click: guardarDatosPlanoPadreHijo
    		},
	        {
	    		id: "cerrarSelecPlanoHijo",
	    		text: $.rup.i18n.base.rup_global.cancelar,
	        	click: function() {
	        		$("#selecPlanoHijo").rup_dialog("close");
	        	},
	        	btnType:$.rup.dialog.LINK
        	}]
      });
	$("#aceptarSelecPlanoHijo").hide();
}

function obtenerIdiomaCombo(){
	var idioma="c";		
	if ($.rup_utils.capitalizedLang() =="Es") {	
		idioma = "c";
	} else idioma="e";
	return idioma;
	}

function comprobarCombos(){
	//Si no ha seleccionado Edificio Zona y Planta no se muestra el botón de Aceptar
	if ($("#comboEdificios").val()=="" || $("#comboZonas").val() =="" || $("#comboPlantas").val()==""){
		$("#aceptarSelecPlanoHijo").hide();
	}else{
		$("#aceptarSelecPlanoHijo").show();
	}
}

function guardarDatosPlanoPadreHijo(){
	var idPlanoPadre = $("#idplano").val();
	var codEdificio = $("#comboEdificios").rup_combo("value");
	var codZona = $("#comboZonas").rup_combo("value");
	var codPlanta = $("#comboPlantas").rup_combo("value");
	
	$.ajax({
		  type: "POST",				  
		  url: "../planos/asociarPadreHijo",
		  data:  { idPlanoPadre:idPlanoPadre,codEdificio:codEdificio,codZona:codZona,codPlanta:codPlanta,ejeXdesde:coordX,ejeYdesde:coordY},
		  success: function(dataAsociado){
			  if (dataAsociado==true){
				  	$.rup_messages("msgOK", { 
				  		title: $.rup.i18n.app.comun.control,
				  		message: $.rup.i18n.app.mensajesPlano.planoAsociado 
				  	});
				  	$("#selecPlanoHijo").rup_dialog("close");
				  	$("#lupaPlano").rup_dialog("close");
			  }else{
					$.rup_messages("msgAlert", { 
			 			title: $.rup.i18n.app.comun.control,
				 		message: "Error al asociar planos. asociarPadreHijo"
				 	});
					  return false;
				  }
		  		},
		  error: function() {
				$.rup_messages("msgAlert", { 
		 			title: $.rup.i18n.app.comun.control,
			 		message: "Error al asociar planos. asociarPadreHijo"
			 	});
				  return false;
			  },
		  dataType: "json"
		});
	
}